Graphics3D 800,600,32,2
SetBuffer BackBuffer()
AppTitle "Kernle 32DLL - TankZ WarZ - FinalBuild 4"
SeedRnd MilliSecs()

;-----------------------------------

light = CreateLight(2)
PositionEntity light,0,100,0
LightColor light,10,10,10

;-----------------------------------

Type Player
	Field IP%,Port%,HP%,Score,Nickname$
	Field TankMesh,TankTurret,ColMesh
	
	Field TimeOut%
End Type
Global Player.Player,Players

Type Particle
	Field Mesh,OwnerIP%,OwnerPort%
	
	Field SpeedCounter,LastUpdated,Speed
End Type
Global Particle.Particle

Type Bang
	Field Mesh,SizeAdd,Alpha#
	
	Field SpeedCounter,LastUpdated,Speed
End Type
Global Bang.Bang

Function AddPlayer(Nick$,IP%,Port%,HP%=100,X#=0,Z#=0,YRot1#=0,YRot2#=0)
	For Player = Each Player
		If Player\IP% = IP% And Player\Port% = Port% Then Return -1
	Next
	
	Player = New Player
	Player\IP% = IP%
	Player\Port% = Port%
	
	Player\TankMesh = LoadMesh("TankBase_B.x")
	Player\TankTurret = LoadMesh("TankTurret_B.x",Player\TankMesh)
	Player\HP% = HP%
	Player\Nickname$ = Nick$
	
	PositionEntity Player\TankTurret,0,12.5,-15
	
	;------------
	
	If IP = MyIP And Port = MyPort%
		W = Rnd(0,3)
		PositionEntity Player\TankMesh,Sin#(W*90)*400,0,Cos#(W*90)*400
		RotateEntity Player\TankMesh,0,180-W*90,0
	Else
		PositionEntity Player\TankMesh,X,0,Z
		RotateEntity Player\TankMesh,0,YRot1+90,0
		RotateEntity Player\TankTurret,0,YRot2,0
	EndIf
	
	EntityRadius Player\TankMesh,MeshWidth#(Player\TankMesh)-5
	EntityType Player\TankMesh,3
	EntityType Player\TankTurret,3
	
	;------------
	
	If IsMe(IP%,Port%)
		Camera = CreateCamera(Player\TankTurret)
	EndIf
	
	Players = Players + 1
	
	Return 1
End Function

Function AddParticle(IP%,Port%)
	Player = First Player
	
	If (IP% = MyIP% And Port% = MyPort%) = 0
		For Player = Each Player
			If Player\IP% = IP% And Player\Port% = Port% Then found = 1 : Exit
		Next
	EndIf
	
	TFormPoint 0,6.25,35, Player\TankTurret, 0
	Particle = New Particle
	Particle\mesh = CreateSphere(8)
	PositionEntity Particle\Mesh,TFormedX(),TFormedY(),TFormedZ()
	TurnEntity Particle\Mesh,Rnd(-2,2),EntityYaw(Player\TankTurret,1)+Rnd(-2,2),0
	EntityTexture Particle\mesh,ParticleTexture
	ScaleMesh Particle\Mesh,1,1,2
	Particle\Speed=10
	EntityType Particle\Mesh,1
	
	Particle\OwnerIP = IP%
	Particle\OwnerPort = Port%
End Function

Function IntegerIP(IP$)
	a1=Int(Left(IP$,Instr(IP$,".")-1)):IP$=Right(IP$,Len(IP$)-Instr(IP$,"."))
	a2=Int(Left(IP$,Instr(IP$,".")-1)):IP$=Right(IP$,Len(IP$)-Instr(IP$,"."))
	a3=Int(Left(IP$,Instr(IP$,".")-1)):IP$=Right(IP$,Len(IP$)-Instr(IP$,"."))
	a4=Int(IP$)
	Return (a1 Shl 24) + (a2 Shl 16) + (a3 Shl 8 ) +a4
End Function

;-----------------------------------

Global Camera
Global Plane = LoadMesh("Map2F_B.x")
EntityType Plane,2

PositionEntity Plane,0,-1,0

Global BangTexture = LoadTexture("realfire.jpg")
Global ParticleTexture = LoadTexture("Water.png")

;-----------------------------------

CountHostIPs("")
Global IsServer,ServerIP,UDP_Stream,MyPort%,ServerTimeOut,MyIP% = HostIP(1),MyNick$
Const UDP_Server_Port = 8000, DMG = 2, PackageTime = 12, TimeoutTime = 10000

;-----------------------------------

Print "Kernle 32DLL - TankZ WarZ - 16,3kb - unoptimized"
Print "------------------------------------------------"
Print ""
Print "Your IP is: "+DottedIP(MyIP)
Print ""

.newnick
MyNick = Input("Enter Nickname:")
If MyNick = "" Then Goto newnick

IsServer = Input("ServerMode ? (0 / 1):")

If IsServer = 1
	UDP_Stream = CreateUDPStream(UDP_Server_Port)
	MyPort% = UDP_Server_Port
	
	AddPlayer(MyNick,MyIP,MyPort%) ;we...
Else
	UDP_Stream = CreateUDPStream()
	
	Print "type in the ip-adress you wanna join:"
	ServerIP = IntegerIP(Input$("xxx.xxx.xxx.xxx -> "))
	
	If ServerIP = IntegerIP("127.0.0.1") Then ServerIP = MyIP%
	
	WriteByte UDP_Stream,0
	WriteString UDP_Stream,MyNick
	
	SendUDPMsg UDP_Stream,ServerIP,UDP_Server_Port
	
	Repeat
		JoinOK% = ProccessNetData()
		If JoinOK% = 2 Then Exit
	Forever
EndIf

;-----------------------------------

RotateEntity Camera,20,0,0
PositionEntity Camera,0,50,-70

Pl_Speed = 2

;-----------------------------------

Repeat
	PositionTexture BangTexture,Rnd(-0.01,0.01),Rnd(-0.01,0.01)
	
	UpdateMillisecs = MilliSecs()
	
	ProccessNetData()
	
	MoveZ = 0
	RotY1 = 0
	RotY2 = 0
	
	If KeyDown(17) Then MoveZ = 1
	If KeyDown(31) Then MoveZ = -1
	
	If KeyDown(30) Then RotY1 = 1
	If KeyDown(32) Then RotY1 = -1
	
	If KeyDown(203) Then RotY2 = 1
	If KeyDown(205) Then RotY2 = -1
	
	If KeyDown(57) And NextShot < MilliSecs() Then SendShoot() : NextShot = MilliSecs()+60
	
	Player = First Player
	
	Pl_SpeedCounter = UpdateMillisecs-Pl_LastUpdated
	AnimSteps = (Pl_SpeedCounter-(Pl_SpeedCounter Mod Pl_Speed))/Pl_Speed
	
	If Pl_SpeedCounter > Pl_Speed-1
		MoveEntity Player\TankMesh,0,0,Float(AnimSteps)*0.2*Float(MoveZ)			
		TurnEntity Player\TankMesh,0,Float(AnimSteps)*0.2*Float(RotY1),0
		TurnEntity Player\TankTurret,0,Float(AnimSteps)*0.2*Float(RotY2),0
		
		Pl_LastUpdated = UpdateMillisecs
				
		If NextSend < MilliSecs()
			NextSend = MilliSecs()+PackageTime
			SendPlayerCords()
		EndIf
	EndIf
	
	For Particle = Each Particle
		Particle\SpeedCounter = UpdateMillisecs-Particle\LastUpdated
		AnimSteps = (Particle\SpeedCounter-(Particle\SpeedCounter Mod Particle\Speed))/Particle\Speed
		
		If Particle\SpeedCounter > Particle\Speed-1
			MoveEntity Particle\Mesh,0,0,5
			Particle\LastUpdated = UpdateMillisecs
		EndIf
	Next
	
	For Particle = Each Particle
		PlaneCols = CountCollisions(Particle\Mesh)
		For i = 1 To PlaneCols
			Entity = CollisionEntity(Particle\Mesh,i)
			Typ = GetEntityType(Entity)
			
			If Particle\OwnerIP = MyIP And Particle\OwnerPort = MyPort And Typ = 3 ;player
				For Player = Each Player
					If Player\TankMesh = Entity Or Player\TankTurret = Entity
						IP = Player\IP%
						Port = Player\Port%
						HP = Player\HP-DMG
						
						SendDamage(IP%,Port%)
						If HP <= 0 Then SendKill(IP%,Port%)
						Exit
					EndIf
				Next
			EndIf
			
			AddBang(EntityX(Particle\Mesh),EntityY(Particle\Mesh),EntityZ(Particle\Mesh),Rnd(-5,5))
			FreeEntity(Particle\Mesh)
			Delete Particle
		Next
	Next
	
	For Bang = Each Bang
		Bang\SpeedCounter = UpdateMillisecs-Bang\LastUpdated
		AnimSteps = (Bang\SpeedCounter-(Bang\SpeedCounter Mod Bang\Speed))/Bang\Speed
		
		If Bang\SpeedCounter > Bang\Speed-1
			Bang\Alpha = Bang\Alpha - 0.05*Float(AnimSteps)
			Scale# = (1.5-Bang\Alpha)*(10.0+Bang\SizeAdd)
			ScaleEntity Bang\Mesh,Scale,Scale,Scale
			Bang\LastUpdated = UpdateMillisecs
			If Bang\Alpha < 0 Then FreeEntity Bang\Mesh : Delete Bang Else EntityAlpha Bang\Mesh,Bang\Alpha
		EndIf
	Next
	
	Collisions 1,2,2,1
	Collisions 1,3,2,1
	
	Collisions 3,2,2,2
	
	UpdateWorld
	RenderWorld
	
	If (ServerTimeOut-MilliSecs()) < 0 And IsServer = 0
		Color 255,0,0
		Cls : Text 1,1,"Lost connection to server... X_X" : Flip
		CloseUDPStream UDP_Stream
		FlushKeys() : WaitKey()
		End
	ElseIf (ServerTimeOut-MilliSecs()) < TimeoutTime*0.5 And IsServer = 0
		Color 255,0,0
		Text 1,1,"CONNECTION LOST ? ("+(ServerTimeOut-MilliSecs())/1000+")"
	ElseIf (ServerTimeOut-MilliSecs()) < TimeoutTime*0.8 And IsServer = 0
		Color 255,255,0
		Text 1,1,"CONNECTION PROBLEM ? ("+(ServerTimeOut-MilliSecs())/1000+")"
	Else
		Color 0,255,0
		Text 1,1,"CONNECTION FINE"
	EndIf
	
	Color 255,255,255
	sendtimer = NextSend - MilliSecs() : If sendtimer < 0 Then sendtimer = 0
	Text 1,13,"Rendertime: "+rendertimeend
	
	If IsServer = 1
		.retime
		
		For Player = Each Player
			 If IsMe(Player\IP%,Player\Port%) = 0 And (Player\TimeOut-MilliSecs()) < 0
				PlIP% = Player\IP%
				PlPort% = Player\Port%
				
				FreeEntity Player\TankMesh
				Delete Player
				Players% = Players% - 1
				
				For Player = Each Player
					If IsMe(Player\IP%,Player\Port%) = 0
						WriteByte(UDP_Stream,5)
						WriteInt(UDP_Stream,PlIP%) : WriteInt(UDP_Stream,PlPort%)
						SendUDPMsg UDP_Stream,Player\IP%,Player\Port%
					EndIf
				Next
				
				Goto retime
			EndIf
		Next
	EndIf
	
	I = 0
	For Player = Each Player
		I = I + 1
		ProblemVar$ = ""
		
		If IsServer = 1 And IsMe(Player\IP%,Player\Port%) = 0
			If (Player\TimeOut-MilliSecs()) < TimeoutTime*0.5
				ProblemVar$ = " | CONNECTION LOST ? ("+(Player\TimeOut-MilliSecs())/1000+")"
			ElseIf (Player\TimeOut-MilliSecs()) < TimeoutTime*0.8
				ProblemVar$ = " | CONNECTION PROBLEM ? ("+(Player\TimeOut-MilliSecs())/1000+")"
			EndIf
		EndIf
		
		Text 1,25+I*12,Player\Nickname$+": HP: "+Player\HP+"/100"+" | Score: "+Player\Score+ProblemVar$
		
		ResetEntity Player\TankMesh : ResetEntity Player\TankTurret
		MoveEntity Player\TankMesh,0,-EntityY(Player\TankMesh),0
		PositionEntity Player\TankTurret,0,12.5,-15
		EntityType Player\TankMesh,3 : EntityType Player\TankTurret,3
		
		If IsMe(Player\IP%,Player\Port%) = 0
			CameraProject (Camera,EntityX(Player\TankMesh),20,EntityZ(Player\TankMesh))
			Text ProjectedX(),ProjectedY(),Player\Nickname$,1,1
		EndIf
	Next
	
	Flip 0
	
	rendertimeend = MilliSecs()-UpdateMillisecs
	
	If KeyHit(1) Then Exit
Forever

WriteByte UDP_Stream,1
SendUDPMsg UDP_Stream,ServerIP,UDP_Server_Port
CloseUDPStream UDP_Stream

End

Function ProccessNetData()
	IP% = RecvUDPMsg(UDP_Stream)
	
	If IP%
		Port% = UDPMsgPort(UDP_Stream)
		Select ReadByte(UDP_Stream)
			Case 0 ;player wants to join (from: client | to: server)
				NewNick$ = ReadString(UDP_Stream)
				
				For Player = Each Player
					If (Player\IP% = IP% And Player\Port% = Port%) Or (Player\Nickname$ = NewNick$) Then found = 1 : Exit
				Next
				
				If found = 1
					WriteByte(UDP_Stream,2)
					SendUDPMsg UDP_Stream,IP%,Port%
				Else
					WriteByte(UDP_Stream,3) ;nice, join !
					WriteInt(UDP_Stream,Port%)
					WriteInt(UDP_Stream,Players%)
					
					For Player = Each Player ;that are the other players
						WriteInt(UDP_Stream,Player\IP%)
						WriteInt(UDP_Stream,Player\Port%)
						WriteByte(UDP_Stream,Player\HP%)
						WriteString(UDP_Stream,Player\Nickname$)
						WriteFloat(UDP_Stream,EntityX(Player\TankMesh))
						WriteFloat(UDP_Stream,EntityZ(Player\TankMesh))
						WriteFloat(UDP_Stream,EntityYaw(Player\TankMesh,1))
						WriteFloat(UDP_Stream,EntityYaw(Player\TankTurret,1))
					Next
					
					SendUDPMsg UDP_Stream,IP%,Port%
					
					;now send to everyone else a notice of the new player
					For Player = Each Player
						If IsMe(Player\IP%,Player\Port%) = 0
							WriteByte(UDP_Stream,4)
							WriteInt(UDP_Stream,IP%) : WriteInt(UDP_Stream,Port%)
							WriteString(UDP_Stream,NewNick$)
							SendUDPMsg UDP_Stream,Player\IP%,Player\Port%
						EndIf
					Next
					
					AddPlayer(NewNick$,IP%,Port%)
				EndIf
			Case 1 ;player wants to leave (from: client | to: server)
				For Player = Each Player
					If Player\IP% <> IP% And Player\Port% <> Port%
						If IsMe(Player\IP%,Player\Port%) = 0
							WriteByte(UDP_Stream,5)
							WriteInt(UDP_Stream,IP%) : WriteInt(UDP_Stream,Port%)
							SendUDPMsg UDP_Stream,Player\IP%,Player\Port%
						EndIf
					EndIf
				Next
			Case 2 ;join invalid (from: server | to: client)
				Print "cant join server - ip, port or nickname already in use"
				CloseUDPStream UDP_Stream
				FlushKeys() : WaitKey()
				End
			Case 3 ;join ok (from: server | to: client)
				MyPort% = ReadInt(UDP_Stream)
				AddPlayer(MyNick$,MyIP%,MyPort%)
				
				TempPlayers = ReadInt(UDP_Stream)
				
				For I = 1 To TempPlayers
					PlIP% = ReadInt(UDP_Stream)
					PlPort% = ReadInt(UDP_Stream)
					PlHP% = ReadByte(UDP_Stream)
					PlNick$ = ReadString(UDP_Stream)
					X# = ReadFloat(UDP_Stream)
					Z# = ReadFloat(UDP_Stream)
					YRot1# = ReadFloat(UDP_Stream)
					YRot2# = ReadFloat(UDP_Stream)
					
					AddPlayer(PlNick$,PlIP%,PlPort%,PlHP%,X,Z,YRot1,YRot2)
				Next
				
				Return 2
			Case 4 ;add player (from: server | to: client)
				PlIP% = ReadInt(UDP_Stream)
				PlPort% = ReadInt(UDP_Stream)
				PlNick$ = ReadString(UDP_Stream)
				
				AddPlayer(PlNick$,PlIP%,PlPort%)
			Case 5 ;remove player (from: server | to: client)
				PlIP% = ReadInt(UDP_Stream)
				PlPort% = ReadInt(UDP_Stream)
				
				If IsMe(PlIP%,PlPort%) = 1
					CloseUDPStream UDP_Stream
					End
				EndIf
				
				For Player = Each Player
					If Player\IP% = PlIP% And Player\Port% = PlPort%
						FreeEntity Player\TankMesh
						Delete Player
						Players% = Players% - 1
					EndIf
				Next
			Case 6 ;updated cords (from: client | to: client)
				X# = ReadFloat(UDP_Stream)
				Z# = ReadFloat(UDP_Stream)
				YRot1# = ReadFloat(UDP_Stream)
				YRot2# = ReadFloat(UDP_Stream)
				
				For Player = Each Player
					If Player\IP% = IP% And Player\Port% = Port%
						ResetEntity Player\TankMesh : ResetEntity Player\TankTurret
						PositionEntity Player\TankMesh,X,0,Z
						RotateEntity Player\TankMesh,0,YRot1,0,1
						RotateEntity Player\TankTurret,0,YRot2,0,1
						EntityType Player\TankMesh,3 : EntityType Player\TankTurret,3
						Exit
					EndIf
				Next
			Case 7 ;shooting
				AddParticle(IP%,Port%)
			Case 8 ;take damage
				PlIP% = ReadInt(UDP_Stream)
				PlPort% = ReadInt(UDP_Stream)
				
				For Player = Each Player
					If Player\IP% = PlIP% And Player\Port% = PlPort%
						Player\HP = Player\HP - DMG
						If Player\HP < 0 Then Player\HP = 0
						Exit
					EndIf
				Next
			Case 9 ;kill
				PlIP% = ReadInt(UDP_Stream) ;who got killed
				PlPort% = ReadInt(UDP_Stream)
				
				For Player = Each Player
					If Player\IP% = IP% And Player\Port% = Port%
						Player\Score = Player\Score + 1
					ElseIf Player\IP% = PlIP% And Player\Port% = PlPort%
						Player\HP = 100
						Player\Score = Player\Score - 1
						X# = EntityX(Player\TankMesh)
						Y# = EntityY(Player\TankMesh)
						Z# = EntityZ(Player\TankMesh)
						AddBang(X,Y,Z,100)
						AddBang(X,Y,Z,200)
					EndIf
				Next
				
				Player = First Player
				If PlIP% = MyIP% And PlPort% = MyPort%
					W = Rnd(0,3)
					ResetEntity Player\TankMesh : ResetEntity Player\TankTurret
					PositionEntity Player\TankMesh,Sin#(W*90)*400,0,Cos#(W*90)*400
					RotateEntity Player\TankMesh,0,180-W*90,0
					RotateEntity Player\TankTurret,0,0,0
					EntityType Player\TankMesh,3 : EntityType Player\TankTurret,3
				EndIf
		End Select
		
		If IsServer = 1
			For Player = Each Player
				If Player\IP% = IP% And Player\Port% = Port% Then Player\TimeOut = MilliSecs()+TimeoutTime : Exit
			Next
		EndIf
		
		If ServerIP% = IP% And Port% = 8000 Then ServerTimeOut = MilliSecs()+TimeoutTime
	EndIf
	
	Return 1
End Function

Function SendPlayerCords()
	Player = First Player
	X# = EntityX(Player\TankMesh)
	Z# = EntityZ(Player\TankMesh)
	YRot1# = EntityYaw(Player\TankMesh,1)
	YRot2# = EntityYaw(Player\TankTurret,1)
	
	For Player = Each Player
		If IsMe(Player\IP%,Player\Port%) = 0
			WriteByte(UDP_Stream,6)
			
			WriteFloat(UDP_Stream,X)
			WriteFloat(UDP_Stream,Z)
			WriteFloat(UDP_Stream,YRot1)
			WriteFloat(UDP_Stream,YRot2)
			
			SendUDPMsg UDP_Stream,Player\IP%,Player\Port%
		EndIf
	Next
End Function

Function SendShoot()
	Player = First Player
	AddParticle(MyIP%,MyPort%)
	
	For Player = Each Player
		If IsMe(Player\IP%,Player\Port%) = 0
			WriteByte(UDP_Stream,7)
			SendUDPMsg UDP_Stream,Player\IP%,Player\Port%
		EndIf
	Next
End Function

Function SendDamage(IP%,Port%)
	For Player = Each Player
		If Player\IP% = IP% And Player\Port% = Port%
			Player\HP = Player\HP - DMG
			If Player\HP < 0 Then Player\HP = 0
			Exit
		EndIf
	Next
	
	For Player = Each Player
		If IsMe(Player\IP%,Player\Port%) = 0
			WriteByte(UDP_Stream,8)
			WriteInt(UDP_Stream,IP)
			WriteInt(UDP_Stream,Port)
			SendUDPMsg UDP_Stream,Player\IP%,Player\Port%
		EndIf
	Next
End Function

Function SendKill(IP%,Port%)
	Player = First Player
	Player\Score = Player\Score + 1
	
	For Player = Each Player
		If Player\IP% = IP% And Player\Port% = Port%
			Player\HP = 100
			Player\Score = Player\Score - 1
			X# = EntityX(Player\TankMesh)
			Y# = EntityY(Player\TankMesh)
			Z# = EntityZ(Player\TankMesh)
			AddBang(X,Y,Z,100)
			AddBang(X,Y,Z,200)
			Exit
		EndIf
	Next
	
	For Player = Each Player
		If IsMe(Player\IP%,Player\Port%) = 0
			WriteByte(UDP_Stream,9)
			WriteInt(UDP_Stream,IP)
			WriteInt(UDP_Stream,Port)
			SendUDPMsg UDP_Stream,Player\IP%,Player\Port%
		EndIf
	Next
End Function

Function IsMe(IP%,Port%)
	Return (IP% = MyIP% And Port% = MyPort%)
End Function

Function AddBang(X#,Y#,Z#,SizeAdd#=0)
	Bang = New Bang
	Bang\Mesh = CreateSphere(8)
	Bang\Alpha = 1.0
	Bang\SizeAdd = SizeAdd
	Bang\Speed = 10+(SizeAdd/10)
	Bang\LastUpdated = MilliSecs()
	PositionEntity Bang\Mesh,X,Y,Z
	EntityTexture Bang\Mesh,BangTexture 
End Function